#!/usr/bin/perl

###############################################################################
# AntiLeech.pl
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.1                                                    #
# Released:       November 8, 2005                                            #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2005 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################
# Anti-Leech Mod for YaBB 2.0 & YaBB 2.1
# Add a function for upload Users Avatars on you YaBB forum.
# Version:        1.1                                     													#
# Released:       July 01 th, 2006                                         												#
# =============================================================================
# Written by Edwin Witte (spYder) for the YaBB community
# Website: http://www.spyderweb.nl/
###############################################################################

use CGI qw(:standard); 	
$query = new CGI;

### Requirements and Errors ###
$script_root = $ENV{'SCRIPT_FILENAME'};
$script_root =~ s/\/YaBB\.(pl|cgi)//ig;

if (-e "../Paths.pl") { require "../Paths.pl"; }
elsif (-e "$script_root/Paths.pl") { require "$script_root/Paths.pl"; }

$invoer = $query->param('file');			# invoer
@ingevoerd = split(/\./, $invoer);			# splits de invoer
$extensie = lc(pop(@ingevoerd));			# extensie van bestand

$view_leechers = $query->param('view_leechers');
&display_leechers if ($view_leechers && $ENV{'REQUEST_METHOD'} eq "GET");

$referrer = $ENV{'HTTP_REFERER'};
$url = $ENV{'HTTP_HOST'};

require "../Variables/AntiLeechcfg.txt";
if ($enableantileech eq "0") {$referrer = "$url";}

  %mime_type = (
         avi => 'video/msvideo',
         bmp => 'image/bmp',           
         gif => 'image/gif',
          gt => 'video/quicktime',
         jpg => 'image/jpeg',
        jpeg => 'image/jpeg',
         mid => 'audio/midi',
         mov => 'video/quicktime',
         mp3 => 'audio/mpeg',
         mpg => 'video/mpeg',
        mpeg => 'video/mpeg',
         pdf => 'application/pdf', 
         png => 'image/png',
         pps => 'application/vnd.ms-powerpoint',
         ppt => 'application/vnd.ms-powerpoint',  
          ra => 'audio/x-pn-realaudio',
         swf => 'application/x-shockwave-flash swf',
         txt => 'text/plain',
         waw => 'audio/x-wav',
         wmv => 'video/x-ms-wmv',
         zip => 'application/zip',
               );

if ($referrer =~ /$url/s || $referrer eq "" && $blockemptyref eq "0") 
		
		{

use constant CHUNK_SIZE => 4096;

if (!-e "$uploaddir/$invoer") {&deleted;}

open $file, '<', "$uploaddir/$invoer"
or die "Cannot open $file";

$mime  = $mime_type{"$extensie"};
print $query->header( -type => "$mime",-content_disposition => "attachment;filename=$invoer");

select STDOUT;
$| = 1;
binmode STDOUT;

while ( 1 ) {
$r = sysread $file, $buffer, CHUNK_SIZE;
die "File read error: $!" unless defined $r;
last unless $r;
print STDOUT $buffer;
}

close $file or die "Cannot close $file";

		}
		
else		{

use constant CHUNK_SIZE => 4096;

open $file, '<', "$modimgdir/noaccess.gif"
or die "Cannot open $file";

print $query->header( -type => "image/gif",-content_disposition => "attachment;filename=noaccess.gif");


select STDOUT;
$| = 1;
binmode STDOUT;

while ( 1 ) {
$r = sysread $file, $buffer, CHUNK_SIZE;
die "File read error: $!" unless defined $r;
last unless $r;
print STDOUT $buffer;
}

close $file or die "Cannot close $file";

		}
		
sub deleted     {

use constant CHUNK_SIZE => 4096;

open $file, '<', "$modimgdir/notfound.gif"
or die "Cannot open $file";

print $query->header( -type => "image/gif",-content_disposition => "attachment;filename=notfound.gif");


select STDOUT;
$| = 1;
binmode STDOUT;

while ( 1 ) {
$r = sysread $file, $buffer, CHUNK_SIZE;
die "File read error: $!" unless defined $r;
last unless $r;
print STDOUT $buffer;
}

close $file or die "Cannot close $file";

		}